unit F_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ScktComp, StdCtrls, Winsock, ExtCtrls, ShellApi, C_LinearMemory, base64,
  F_CustHeader;

type
  TForm1 = class(TForm)
    GroupBox2: TGroupBox;
    Label1: TLabel;
    eGet: TEdit;
    Label2: TLabel;
    ePort: TEdit;
    Out: TMemo;
    ClientSocket: TClientSocket;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    cbUseProxy: TCheckBox;
    eProxyAddr: TEdit;
    eProxyPort: TEdit;
    GroupBox3: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    gbInfo: TGroupBox;
    Label5: TLabel;
    lByte: TLabel;
    cbMem: TCheckBox;
    sdMem: TSaveDialog;
    Label6: TLabel;
    lTime: TLabel;
    Label8: TLabel;
    lSpeed: TLabel;
    Label10: TLabel;
    lMax: TLabel;
    Label7: TLabel;
    lStatus: TLabel;
    Label9: TLabel;
    eProxyLogin: TEdit;
    Label11: TLabel;
    eProxyPass: TEdit;
    Button5: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure ClientSocketConnecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientSocketConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Dclarations prives }
    procedure WMDROPFILES(var Message: TWMDROPFILES); message WM_DROPFILES;
  public
    { Dclarations publiques }
    Site : string;
    Path : string;
    SaveToFile : boolean;
    SaveMem : TWriteLinearMemory;
    cps : integer;
    maxCps : integer;
    time : integer;
    Function  SendData(const str : string) : integer;
    procedure GetHttp(const str : string);
    procedure ShowInfo(const str : string);

  end;
function SocketErrorMsg(Error: integer) : string;

const
  CRLF = #13#10;
var
  Form1: TForm1;

implementation

{$R *.DFM}
Function  TForm1.SendData(const str : string) : integer;
begin
  ClientSocket.Socket.SendText(str+CRLF);
  ShowInfo(str);
end;

(*
IExplorer

Direct :
GET / HTTP/1.1
Accept: application/vnd.ms-excel, application/msword, application/vnd.ms-powerpo
int, image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*
Accept-Language: fr
Accept-Encoding: gzip, deflate
User-Agent: Mozilla/4.0 (compatible; MSIE 4.01; Windows NT)
Host: 130.142.153.231:2345
Connection: Keep-Alive

Proxy :
GET http://www.yahoo.com/ HTTP/1.0
Accept: application/vnd.ms-excel, application/msword, application/vnd.ms-powerpo
int, image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*
Accept-Language: fr
Accept-Encoding: gzip, deflate
User-Agent: Mozilla/4.0 (compatible; MSIE 4.01; Windows NT)
Host: www.yahoo.com
Proxy-Connection: Keep-Alive
Cookie: B=0etnb48t1t3e0&b=2&f=s; Y=v=1&n=4apls8ioopj0q&l=8di2h8fj8ed_c06eeij0/o&
p=m2bvvfra11000g&r=75&lg=fr&intl=fr; T=z=AeHQ6AAkcQ6Ab3rdYvgc68qNjY3Bk8wMjUzNzc1
Mw--&a=AAE&sk=DAATka0Ycw4Frq&d=c2wBTVRFd0FUZzNOVEkwTURBeU5BLS0BYQFBQUUBenoBQWVIU
TZBZ1dB


Netscape :

GET / HTTP/1.0
If-Modified-Since: Thu, 21 Dec 2000 11:09:00 GMT
User-Agent: Mozilla/4.7 [fr] (WinNT; I)
Host: 130.142.153.231:2345
Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, image/png, */*
Accept-Encoding: gzip
Accept-Language: fr
Accept-Charset: iso-8859-1,*,utf-8
*)
procedure TForm1.GetHttp(const str : string);
var
  i : integer;
begin
// http://www.adultes.net/videos/exemple1.mpg
  if (cbUseProxy.Checked) then
  begin
    SendData('GET http://'+Site+':'+ePort.Text+str+' HTTP/1.0');
    if (eProxyLogin.Text <> '') then
    begin
      SendData('Proxy-Authorization: Basic '+b64encode(eProxyLogin.Text+':'+eProxyPass.Text));
    end;
  end
  else
  begin
    SendData('GET '+str+' HTTP/1.1');
  end;
  for i := 0 to FCustHeader.Header.Lines.Count - 1 do
    SendData(FCustHeader.Header.Lines[i]);
{  SendData('Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, image/png, */*');
  SendData('Accept-Language: en');
  SendData('Accept-Encoding: gzip');
  SendData('User-Agent: Mozilla/4.7 [fr] (AmstradOS; I)'); // User-Agent: Mozilla/4.7 [fr] (WinNT; I)
  }
  SendData('Host: '+Site+':'+ePort.Text);

  if (cbUseProxy.Checked) then
  begin
    SendData('Proxy-Connection: Keep-Alive');
  end
  else
  begin
    SendData('Connection: Keep-Alive');
  end;
  SendData(#13#10);
end;

procedure TForm1.ShowInfo(const str : string);
begin
  Out.Lines.add(str);
end;

procedure ExtractSiteFromUrl(const url : string ; var site : string ; var path : string);
// url = "http://www.yahoo.fr/prout" -> "www.yahoo.fr" , "/prout"
var
  p : integer;
  i : integer;
  p1, p2 : integer; // first char of adr name, last char of adr name;
  tmp : string;
const
  HTTP = 'HTTP://';
begin
  tmp := UpperCase(url);
  p1 := 0;
  p2 := 0;
  // search for first char of site
  if (pos(HTTP, tmp) = 1) then
  begin // 'http://www.tata.com'
    p1 := length(HTTP)+1;
  end
  else
  begin
    p := pos('://', tmp);
    if (p <> 0) then
    begin // 'ftp://www.tata.com'
      p1 := p + length('://')+1;
    end
    else
    begin // 'www.tata.com'
      p1 := 1;
    end;
  end;
  // search for last char of site
  p := p1;
  while (true) do
  begin
    if (tmp[p] = '/') or (tmp[p] = '\') then
      break;
    inc(p);
    if (p > length(tmp)) then
    begin
      p := -1;
      break;
    end;
  end;
  if (p = -1) then
  begin // not found a '/'
    p2 := length(tmp)
  end
  else
    p2 := p - 1;
  site := Copy(url, p1, p2 - p1 + 1);
  path := Copy(url, p2 + 1, length(url));
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  SaveToFile := cbMem.Checked;
  if (SaveToFile) then
    SaveMem.Size := 0;
  ExtractSiteFromUrl(eGet.Text, Site, Path);
  if path = '' then path := '/';
  ClientSocket.Active := false;
  ClientSocket.Close;
  if (cbUseProxy.Checked) then
  begin
    ClientSocket.Address := eProxyAddr.Text;
    ClientSocket.Port := StrToInt(eProxyPort.Text);
  end
  else
  begin
    ClientSocket.Address := Site;
    ClientSocket.Port := StrToInt(ePort.Text);
  end;
  ShowInfo(Format('Getting %s from %s', [path, Site]));
  ClientSocket.Open;
end;

procedure TForm1.ClientSocketConnecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  ShowInfo('Connecting...');
  cps := 0;
  maxcps := 0;
  time := GetTickCount;
  lStatus.Caption := 'Connected';
end;

procedure TForm1.ClientSocketDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  ShowInfo('---------------------------');
  ShowInfo('Disconnected');
  lStatus.Caption := 'Not connected';
end;

procedure TForm1.ClientSocketError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  ShowInfo(Format('Error %d (%s)', [ErrorCode, SocketErrorMsg(ErrorCode) ]));
  ErrorCode := 0;
  lStatus.Caption := 'Not connected';
end;

procedure TForm1.ClientSocketConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  ShowInfo('Sending get');
// sendraw("GET ".$notespath." HTTP\/1.0\r\n\r\n");
//  SendData('GET '+path+' HTTP/1.1'+#13#10+'Host: lll.lll.com'#13#10#13#10);
  GetHttp(path);
  ShowInfo('---------------------------');
end;

procedure TForm1.ClientSocketRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  s : string;
  c : single;
const
  T : integer = 0;
begin
  s := Socket.ReceiveText;
  ShowInfo(S);
  If (SaveToFile) then
    SaveMem.WriteRawString(s);
  inc(cps, Length(s));
  T := GetTickCount - Time;
  if (T <> 0) then
  begin
    c := cps / T;
    if (Trunc(c) > MaxCps) then MaxCps := Trunc(c);
  end;
//  lSpeed.Caption := Format('RX bytes : %d in %.2fs, Bps : %f, max Bps : %d', [cps, (GetTickCount - Time) / 1000, c, maxcps]);
  lByte.Caption := IntToStr(cps);
  lTime.Caption := Format('%.2fs', [(GetTickCount - Time) / 1000]);
  lSpeed.Caption := Format('%.2fKBps', [c]);
  lMax.Caption := IntToStr(MaxCps)+'KBps';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DragAcceptFiles(Handle, True);
  SaveMem := TWriteLinearMemory.Create;
end;


procedure TForm1.WMDROPFILES(var Message: TWMDROPFILES);
var
  NumFiles : longint;
  i : longint;
  buffer : array[0..255] of char; 
begin 
{How many files are being dropped} 
  NumFiles := DragQueryFile(Message.Drop,
                            -1,
                            nil, 
                            0); 
{Accept the dropped files} 
  for i := 0 to (NumFiles - 1) do begin 
    DragQueryFile(Message.Drop, 
                  i, 
                  @buffer, 
                  sizeof(buffer)); 
    ShowInfo(buffer); 
  end; 
end;


procedure TForm1.FormDestroy(Sender: TObject);
begin
  SaveMem.Free;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ClientSocket.Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if (SaveMem.Size = 0) then
  begin
    ShowMessage('No data captured !');
  end
  else
  begin
    if (cbMem.Checked) and (sdMem.Execute) then
      SaveMem.SaveToFile(sdMem.FileName);
  end;
end;

function SocketErrorMsg(Error: integer) : string;
begin
  case Error of
    WSAEINTR:
      SocketErrorMsg := 'Interrupted system call';
    WSAEBADF:
      SocketErrorMsg := 'Bad file number';
    WSAEACCES:
      SocketErrorMsg := 'Permission denied';
    WSAEFAULT:
      SocketErrorMsg := 'Bad address';
    WSAEINVAL:
      SocketErrorMsg := 'Invalid argument';
    WSAEMFILE:
      SocketErrorMsg := 'Too many open files';
    WSAEWOULDBLOCK:
      SocketErrorMsg := 'Operation would block';
    WSAEINPROGRESS:
      SocketErrorMsg := 'Operation now in progress';
    WSAEALREADY:
      SocketErrorMsg := 'Operation already in progress';
    WSAENOTSOCK:
      SocketErrorMsg := 'Socket operation on non-socket';
    WSAEDESTADDRREQ:
      SocketErrorMsg := 'Destination address required';
    WSAEMSGSIZE:
      SocketErrorMsg := 'Message too long';
    WSAEPROTOTYPE:
      SocketErrorMsg := 'Protocol wrong type for socket';
    WSAENOPROTOOPT:
      SocketErrorMsg := 'Protocol not available';
    WSAEPROTONOSUPPORT:
      SocketErrorMsg := 'Protocol not supported';
    WSAESOCKTNOSUPPORT:
      SocketErrorMsg := 'Socket type not supported';
    WSAEOPNOTSUPP:
      SocketErrorMsg := 'Operation not supported on socket';
    WSAEPFNOSUPPORT:
      SocketErrorMsg := 'Protocol family not supported';
    WSAEAFNOSUPPORT:
      SocketErrorMsg := 'Address family not supported by protocol family';
    WSAEADDRINUSE:
      SocketErrorMsg := 'Address already in use';
    WSAEADDRNOTAVAIL:
      SocketErrorMsg := 'Can''t assign requested address';
    WSAENETDOWN:
      SocketErrorMsg := 'Network is down';
    WSAENETUNREACH:
      SocketErrorMsg := 'Network is unreachable';
    WSAENETRESET:
      SocketErrorMsg := 'Network dropped connection on reset';
    WSAECONNABORTED:
      SocketErrorMsg := 'Software caused connection abort';
    WSAECONNRESET:
      SocketErrorMsg := 'Connection reset by peer';
    WSAENOBUFS:
      SocketErrorMsg := 'No buffer space available';
    WSAEISCONN:
      SocketErrorMsg := 'Socket is already connected';
    WSAENOTCONN:
      SocketErrorMsg := 'Socket is not connected';
    WSAESHUTDOWN:
      SocketErrorMsg := 'Can''t send after socket shutdown';
    WSAETOOMANYREFS:
      SocketErrorMsg := 'Too many references: can''t splice';
    WSAETIMEDOUT:
      SocketErrorMsg := 'Connection timed out';
    WSAECONNREFUSED:
      SocketErrorMsg := 'Connection refused';
    WSAELOOP:
      SocketErrorMsg := 'Too many levels of symbolic links';
    WSAENAMETOOLONG:
      SocketErrorMsg := 'File name too long';
    WSAEHOSTDOWN:
      SocketErrorMsg := 'Host is down';
    WSAEHOSTUNREACH:
      SocketErrorMsg := 'No route to host';
    WSAENOTEMPTY:
      SocketErrorMsg := 'Directory not empty';
    WSAEPROCLIM:
      SocketErrorMsg := 'Too many processes';
    WSAEUSERS:
      SocketErrorMsg := 'Too many users';
    WSAEDQUOT:
      SocketErrorMsg := 'Disc quota exceeded';
    WSAESTALE:
      SocketErrorMsg := 'Stale NFS file handle';
    WSAEREMOTE:
      SocketErrorMsg := 'Too many levels of remote in path';
    WSASYSNOTREADY:
      SocketErrorMsg := 'Network sub-system is unusable';
    WSAVERNOTSUPPORTED:
      SocketErrorMsg := 'WinSock DLL cannot support this application';
    WSANOTINITIALISED:
      SocketErrorMsg := 'WinSock not initialized';
    WSAHOST_NOT_FOUND:
      SocketErrorMsg := 'Host not found';
    WSATRY_AGAIN:
      SocketErrorMsg := 'Non-authoritative host not found';
    WSANO_RECOVERY:
      SocketErrorMsg := 'Non-recoverable error';
    WSANO_DATA:
      SocketErrorMsg := 'No Data';
  else
    SocketErrorMsg := 'Unknown WinSock error';
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  FCustHeader.ShowModal;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Out.Clear;
end;

end.
