{$I PIETOOLS.INC}
unit PieToolsReg;

interface
{$DEFINE PIECPLUSPLUS}

USES DsgnIntf;

{$IFDEF D5_OR_HIGHER}
TYPE
  TPieToolsCategory = class(TPropertyCategory)
  public
    class function Name: string; override;
    class function Description: string; override;
  end;
{$ENDIF}

procedure Register;

implementation

uses
  Classes, graphics, pieHerk,
  PieValEd, PieZln1, PieMemoDialog1, PieList,
  PieStat, PieImage, PieJahresKalender,
  PieTransparentControls, PiePageControl,
  PiePrinter, PieRahmen, PieLED, PiePfeil,
  PieTaschenrechner, PieTacho, PieComboBox,
  PieGrid, PieProgressBar,
  PieEffekt, PieDigit, PieRegistry, PieVersionInfo,
  PieDataGrid, PieMainMenu;
{ ************************************************* }
{$IFDEF D5_OR_HIGHER}
class function TPieToolsCategory.Name: string;
BEGIN
  Result := 'PieTools';
END;
class function TPieToolsCategory.Description: string;
BEGIN
  Result := 'Extended properties from PieTools';
END;
{$ENDIF}
{ ************************************************* }
procedure Register;
begin
{ ************************************************* }
 RegisterComponents('PieTools',
   [TPieValidateEdit, TPieExtValEdit, TPieDBExtValEdit, TPieList,
    TPieComboBox, TPieCheckBox, TPieButton, TPiePageControl,
    TPieMainMenu, TPiePrinter, TPieFrame,
    TPieImage, TPieStringGrid, TPieScrollText, TPieDigit,
    TPieHistogram, TPieTacho, TPieProgressBar, TPieLED, TPieLEDLabel,
    TPieArrow, TPieEffect, TPieZeilenDialog, TPieMemoDialog,
    TPieYearCalendar, TPieVersionInfo,
    TPieDataGrid, TPieDBDataGrid, TPieCalculator]);
{ ************************************************* }
  RegisterComponentEditor(TPieEffect, TPieEffectEditor);
  RegisterComponentEditor(TPieList, TPieListEditor);
  RegisterComponentEditor(TPieDigit, TPieDigitEditor);
  RegisterComponentEditor(TPieComboBox, TPieComboBoxEditor);
{ ************************************************* }
  RegisterPropertyEditor(TypeInfo(TFont), TPiePrinter,
                         '', TFontProperty );
  RegisterPropertyEditor(TypeInfo(TPen), TPiePrinter,
                         '', TClassProperty );
{ ************************************************* }
{$IFDEF D5_OR_HIGHER}
  RegisterPropertiesInCategory(TPieToolsCategory, TPieCheckBox,
    ['CheckBoxPosition', 'CheckBoxStyle', 'CheckBoxSize', 'CheckBoxTransparent',
     'FocusStyle', 'HookStyle', 'Transparent', 'WordWrap', 'Layout',
     'FocusColor', 'HookColor', 'ButtonEffect']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieButton,
    ['Alignment', 'ButtonLayout', 'Glyph', 'Layout', 'Margin', 'ModalResult',
     'FocusStyle', 'Spacing', 'Transparent', 'WordWrap', 'FocusColor',
     'Background', 'ShowBackground']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieMainMenu,
    ['Background', 'MenuHeight', 'MenuStyle', 'SelectImage',
     'SelectStyle', 'SelectColor', 'Font']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieList,
    ['AnyColors', 'AnyFonts', 'Background', 'BackgroundStyle', 'BitmapStyle',
     'HorzScrollBar', 'Items', 'ItemHeightStyle', 'SelectedStyle',
     'HeaderFont', 'HeaderImages', 'HeaderSections', 'HeaderStyle',
     'LineByTabStops', 'HorzExtent', 'ShowHeader', 'HeaderSections',
     'CheckBoxStyle', 'HookStyle', 'HookColor', 'CheckBoxes', 'SortColumn',
     'Sorted', 'SortUp', 'CheckBoxSize', 'Version',
     'OnSectionClick', 'OnColumnSort', 'OnSortProgress', 'OnPopup']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieComboBox,
    ['AnyColors', 'AnyFonts', 'Background', 'BackgroundStyle', 'BitmapStyle',
     'ItemHeightStyle', 'BoldStyle', 'HeaderControl',
     'HeaderFont', 'HeaderImages', 'HeaderSections', 'HeaderStyle',
     'LineByTabStops', 'Version']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieDigit,
    ['Decimals', 'DigitBitmap', 'DigitCount', 'DigitScrolling',
     'DigitStyle', 'Value']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieValidateEdit,
    ['DecimalPlaces', 'MaxValue', 'MinValue', 'ValEditTyp',
     'Validate', 'ValidateMessage', 'OnChange', 'OnEnter', 'OnExit',
     'OnValidateError', 'OnValidExit']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieExtValEdit,
    ['Header', 'PictureHeader', 'PictureRange', 'Pictures',
     'UnitBevelInner', 'UnitBevelOuter', 'UnitValue', 'UnitWidth',
     'HeaderFont', 'UnitFont', 'UnitPanelColor', 'Filter']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieImage,
    ['FileName', 'Frame', 'FrameWidth', 'ImageType',
     'FrameColor', 'Picture']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieProgressBar,
    ['Decimals', 'Max', 'Min', 'NumSegment', 'Orientation', 'Position',
     'ShowText', 'Smooth', 'Step', 'TextUnit', 'OnChange',
     'BackColor', 'BarColor', 'BevelWidth', 'BorderColor',
     'BorderInner', 'BorderOuter', 'BorderWidth']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPiePrinter,
    ['AutoPaging', 'DokumentStatus', 'FontHeight_Promille',
     'Orientation', 'Printermode', 'TabWriteRect', 'TextBase',
     'Title', 'YPosition', 'Tab', 'FooterFont', 'HeaderFont',
     'PageNumberFont', 'Pen', 'Font', 'Brush', 'Alignment',
     'Image', 'ColumnLines']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieHistogram,
    ['NumberOfHorizontalIntervals', 'NumberOfVerticalIntervals',
     'NameXAxis', 'NameYAxis', 'HistogramType', 'HorizontalGrid',
     'VerticalGrid', 'MaxXValue', 'MaxYValue', 'MinXValue', 'MinYValue',
     'ScaleType', 'DigitCount', 'Transparent', 'XAxisPosition',
     'YAxisPosition', 'ShowHorizontalLabels', 'ShowVerticalLabels',
     'BarColor', 'ErrorColor', 'GridColor']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieTacho,
    ['NumberOfIntervals', 'LabelPosition', 'MaxValue', 'MinValue',
     'PinRadius', 'Position', 'Scale', 'ScaleDecimals', 'Transparent',
     'PointerWidth', 'PointerType', 'PinColor', 'ScaleColor',
     'PointerColor']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieEffect,
    ['EffectHeight', 'EffectStyle', 'EffectWidth', 'Shadow',
     'ShadowWidth', 'ValidComponents', 'BorderColor', 'BorderStyle',
     'BorderWidth', 'EffectColor1', 'EffectColor2', 'ShadowColor']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieYearCalendar,
    ['Day', 'Month', 'Year', 'StartOfWeek', 'LongMonths',
     'UseCurrentDate', 'GridLineWidth', 'OnChange', 'OnEnter',
     'OnExit']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieArrow,
    ['ArrowWidth', 'ArrowType', 'StartX', 'StartY',
     'TargetX', 'TargetY', 'Transparent']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPiePageControl,
    ['Background', 'BackgroundForRest']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieLEDLabel,
    ['CharHeight', 'CharWidth', 'CharSpace', 'ActiveLEDColor',
     'InActiveLEDColor', 'LEDStyle', 'SegmentSpace', 'SegmentWidth',
     'ShowInActiveSegments', 'Transparent']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieScrollText,
    ['Interval', 'Items', 'ScrollPixelX', 'ScrollPixelY', 'Start',
     'Transparent', 'LineSpacing']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieVersionInfo,
    ['VersionInfoAvailable', 'MainVersion', 'SubVersion', 'Release', 'Built',
     'StringFileInfo', 'CompanyName', 'FileDescription', 'FileVersion',
     'InternalName', 'LegalCopyright', 'LegalTrademarks', 'OriginalFilename',
     'ProductName', 'ProductVersion', 'Comments', 'FileDate', 'FileName']);
  RegisterPropertiesInCategory(TPieToolsCategory, TDGColumn,
    ['Alignment', 'CheckBoxSize', 'CheckBoxStyle', 'ColStyle',
     'DisplayMask', 'DropDownRows', 'EditMask', 'Format', 'HookColor',
     'HookStyle', 'LimitToList', 'PickList', 'Title']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieDataGrid,
    ['Background', 'Columns', 'DataGridOptions', 'EditorColor',
     'RowCountMin', 'SelectedIndex', 'SortColumn', 'Sorted', 'SortUp',
     'Version',
     'OnBeforeDelete', 'OnBeforeInsert', 'OnEditButtonClick', 'OnChange',
     'OnFixedCellClick', 'OnSortProgress', 'OnColumnSort']);
  RegisterPropertiesInCategory(TPieToolsCategory, TPieDBDataGrid,
    ['DataField', 'DataSource']);
{$ENDIF}
end;

end.
