{
@abstract(a unit to handle special characters)
@author(Marco Schmidt (marcoschmidt@geocities.com))
@created(6 Feb 2000)
@lastmod(20 Apr 2000)
This unit is supposed to offer a framework to deal with special characters,
usually those that are not defined in the UTF-7 character set (with integer
values smaller than 128).
Almost all languages (except for English) have at least one special character.
}
unit chars;

{$I platform.inc}

interface

type
  { An enumeration type that has a value for each supported language.
    All values begin with LANG. }
  TLanguage = (LANG_UNDEFINED, LANG_ENGLISH, LANG_FRENCH, LANG_GERMAN,
    LANG_CATALAN, LANG_SPANISH, LANG_DUTCH, LANG_BRASILIAN);

const
  { An array of String values with English names for all languages defined in
    the enumeration type @link(TLanguage). }
  LANGUAGE_NAMES: Array[TLanguage] of String =
    ('Undefined', 'English', 'French', 'German', 'Catalan', 'Spanish',
     'Dutch', 'Brasilian Portuguese');

type
  { Enumeration type listing up all supported special characters. }
  TSpecialCharacter =
  (
    CHAR_SMALL_A_UMLAUT,
    CHAR_BIG_A_UMLAUT,
    CHAR_SMALL_O_UMLAUT,
    CHAR_BIG_O_UMLAUT,
    CHAR_SMALL_U_UMLAUT,
    CHAR_BIG_U_UMLAUT,
    CHAR_SZ,
    CHAR_SMALL_E_ACCENT_AIGU,
    CHAR_SMALL_E_ACCENT_GRAVE,
    CHAR_SMALL_C_CEDILLE,
    CHAR_BIG_E_ACCENT_AIGU,
    CHAR_SMALL_E_ACCENT_CIRC
  );

const
  CHARACTER_INTEGER_VALUES: Array[TSpecialCharacter] of Integer =
  (
    $e4, {CHAR_SMALL_A_UMLAUT}
    $c4, {CHAR_BIG_A_UMLAUT}
    $f6, {CHAR_SMALL_O_UMLAUT}
    $d6, {CHAR_BIG_O_UMLAUT}
    $fc, {CHAR_SMALL_U_UMLAUT}
    $dc, {CHAR_BIG_U_UMLAUT}
    $df, {CHAR_SZ}
    $e9, {CHAR_SMALL_E_ACCENT_AIGU }
    $e8, {CHAR_SMALL_E_ACCENT_GRAVE }
    $e7, {CHAR_SMALL_C_CEDILLE }
    $c9, {CHAR_BIG_E_ACCENT_AIGU }
    $ea  {CHAR_SMALL_E_ACCENT_CIRC }
  );

implementation

begin
end.