unit PlotImpl1;

{-----------------------------------------------------------------------------
This code is private and confidential property of Chemware.

It may not be compiled, printed or distributed by anyone else.

The Original Code is: PlotImpl1.pas.

The Initial Developer of the Original Code is Mat Ballard.
Portions created by Mat Ballard are Copyright (C) 1999 Mat Ballard.
Portions created by Microsoft are Copyright (C) 1998, 1999 Microsoft Corp.
All Rights Reserved.

Contributor(s): Mat Ballard                 e-mail: mat.ballard@chemware.hypermart.net.

Last Modified: 05/15/2001
Current Version: 2.06

This work was created with the Project JEDI VCL guidelines:

        http://www.delphi-jedi.org/Jedi:VCLVCL

in mind.

Purpose:
ActiveX control version of TPlot.


Known Issues:
-----------------------------------------------------------------------------}

interface

uses
  Windows, ActiveX, Classes, Controls, Graphics, Menus, Forms, StdCtrls,
  ComServ, StdVCL, AXCtrls, PlotXControl_TLB, ExtCtrls, Printers,

  Misc, Plot, Plotdefs;

type
  TPlotX = class(TActiveXControl, IPlotX)
  private
    { Private declarations }
    FDelphiControl: TPlot;
    FEvents: IPlotXEvents;
    procedure CanResizeEvent(Sender: TObject; var NewWidth, NewHeight: Integer;
      var Resize: Boolean);
    procedure ClickEvent(Sender: TObject);
    procedure ConstrainedResizeEvent(Sender: TObject; var MinWidth, MinHeight,
      MaxWidth, MaxHeight: Integer);
    procedure DataChangeEvent(Sender: TObject);
    procedure DblClickEvent(Sender: TObject);
    procedure FileCloseEvent(Sender: TObject; TheFile: String);
    procedure FileOpenEvent(Sender: TObject; TheFile: String);
    procedure ResizeEvent(Sender: TObject);
    procedure StyleChangeEvent(Sender: TObject);
  protected
    { Protected declarations }
    procedure DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage); override;
    procedure EventSinkChanged(const EventSink: IUnknown); override;
    procedure InitializeControl; override;
    function Get_About: WideString; safecall;
    function Get_AxesProperties: WideString; safecall;
    function Get_BevelInner: TxBevelCut; safecall;
    function Get_BevelOuter: TxBevelCut; safecall;
    function Get_BorderStyle: TxBorderStyle; safecall;
    function Get_ClickAndDragDelay: Integer; safecall;
    function Get_Color: OLE_COLOR; safecall;
    function Get_ColumnGap: Smallint; safecall;
    function Get_ContourDetail: TxContourDetail; safecall;
    function Get_CreatedBy: WideString; safecall;
    function Get_Ctl3D: WordBool; safecall;
    function Get_Cursor: Smallint; safecall;
    function Get_DataProperties: WideString; safecall;
    function Get_DefaultExtension: WideString; safecall;
    function Get_Description: WideString; safecall;
    function Get_DisplayHistory: Single; safecall;
    function Get_DisplayMode: TxDisplayMode; safecall;
    function Get_DockSite: WordBool; safecall;
    function Get_DoubleBuffered: WordBool; safecall;
    function Get_DragCursor: Smallint; safecall;
    function Get_DragMode: TxDragMode; safecall;
    function Get_Editable: WordBool; safecall;
    function Get_Enabled: WordBool; safecall;
    function Get_FileName: WideString; safecall;
    function Get_Font: IFontDisp; safecall;
    function Get_FullRepaint: WordBool; safecall;
    function Get_Grid: TxGridType; safecall;
    function Get_GridStyle: TxPenStyle; safecall;
    function Get_HelpFile: WideString; safecall;
    function Get_HighFont: IFontDisp; safecall;
    function Get_Locked: WordBool; safecall;
    function Get_Movable: WordBool; safecall;
    function Get_MultiJoin: WideString; safecall;
    function Get_Multiplicity: Byte; safecall;
    function Get_NoSeries: Word; safecall;
    function Get_NoYAxes: Integer; safecall;
    function Get_OutlineWidth: Integer; safecall;
    function Get_ParentColor: WordBool; safecall;
    function Get_ParentCtl3D: WordBool; safecall;
    function Get_PieRowCount: Byte; safecall;
    function Get_PlotType: TxPlotType; safecall;
    function Get_PolarRange: Single; safecall;
    function Get_PrintOrientation: TxPrinterOrientation; safecall;
    function Get_ScreenJob: TxScreenJob; safecall;
    function Get_SeriesProperties: WideString; safecall;
    function Get_UseDockManager: WordBool; safecall;
    function Get_Visible: WordBool; safecall;
    function Get_VisibleDockClientCount: Integer; safecall;
    function Get_XYFastDrawAt: Integer; safecall;
    function Get_ZAngle: Word; safecall;
    function Get_ZLink: WordBool; safecall;
    procedure _Set_Font(const Value: IFontDisp); safecall;
    procedure Set_About(const Value: WideString); safecall;
    procedure Set_AxesProperties(const Value: WideString); safecall;
    procedure Set_BevelInner(Value: TxBevelCut); safecall;
    procedure Set_BevelOuter(Value: TxBevelCut); safecall;
    procedure Set_BorderStyle(Value: TxBorderStyle); safecall;
    procedure Set_ClickAndDragDelay(Value: Integer); safecall;
    procedure Set_Color(Value: OLE_COLOR); safecall;
    procedure Set_ColumnGap(Value: Smallint); safecall;
    procedure Set_ContourDetail(Value: TxContourDetail); safecall;
    procedure Set_CreatedBy(const Value: WideString); safecall;
    procedure Set_Ctl3D(Value: WordBool); safecall;
    procedure Set_Cursor(Value: Smallint); safecall;
    procedure Set_DataProperties(const Value: WideString); safecall;
    procedure Set_DefaultExtension(const Value: WideString); safecall;
    procedure Set_Description(const Value: WideString); safecall;
    procedure Set_DisplayHistory(Value: Single); safecall;
    procedure Set_DisplayMode(Value: TxDisplayMode); safecall;
    procedure Set_DockSite(Value: WordBool); safecall;
    procedure Set_DoubleBuffered(Value: WordBool); safecall;
    procedure Set_DragCursor(Value: Smallint); safecall;
    procedure Set_DragMode(Value: TxDragMode); safecall;
    procedure Set_Editable(Value: WordBool); safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    procedure Set_FileName(const Value: WideString); safecall;
    procedure Set_Font(var Value: IFontDisp); safecall;
    procedure Set_FullRepaint(Value: WordBool); safecall;
    procedure Set_Grid(Value: TxGridType); safecall;
    procedure Set_GridStyle(Value: TxPenStyle); safecall;
    procedure Set_HelpFile(const Value: WideString); safecall;
    procedure Set_HighFont(const Value: IFontDisp); safecall;
    procedure Set_Locked(Value: WordBool); safecall;
    procedure Set_Movable(Value: WordBool); safecall;
    procedure Set_MultiJoin(const Value: WideString); safecall;
    procedure Set_Multiplicity(Value: Byte); safecall;
    procedure Set_NoSeries(Value: Word); safecall;
    procedure Set_NoYAxes(Value: Integer); safecall;
    procedure Set_OutlineWidth(Value: Integer); safecall;
    procedure Set_ParentColor(Value: WordBool); safecall;
    procedure Set_ParentCtl3D(Value: WordBool); safecall;
    procedure Set_PieRowCount(Value: Byte); safecall;
    procedure Set_PlotType(Value: TxPlotType); safecall;
    procedure Set_PolarRange(Value: Single); safecall;
    procedure Set_PrintOrientation(Value: TxPrinterOrientation); safecall;
    procedure Set_ScreenJob(Value: TxScreenJob); safecall;
    procedure Set_SeriesProperties(const Value: WideString); safecall;
    procedure Set_UseDockManager(Value: WordBool); safecall;
    procedure Set_Visible(Value: WordBool); safecall;
    procedure Set_XYFastDrawAt(Value: Integer); safecall;
    procedure Set_ZAngle(Value: Word); safecall;
    procedure Set_ZLink(Value: WordBool); safecall;
  end;

implementation

uses ComObj;

{ TPlotX }

procedure TPlotX.DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage);
begin
  {TODO: Define property pages here.  Property pages are defined by calling
    DefinePropertyPage with the class id of the page.  For example,
      DefinePropertyPage(Class_PlotXPage); }
end;

procedure TPlotX.EventSinkChanged(const EventSink: IUnknown);
begin
  FEvents := EventSink as IPlotXEvents;
end;

procedure TPlotX.InitializeControl;
begin
  FDelphiControl := Control as TPlot;
  FDelphiControl.OnCanResize := CanResizeEvent;
  FDelphiControl.OnClick := ClickEvent;
  FDelphiControl.OnConstrainedResize := ConstrainedResizeEvent;
  FDelphiControl.OnDataChange := DataChangeEvent;
  FDelphiControl.OnDblClick := DblClickEvent;
  FDelphiControl.OnFileClose := FileCloseEvent;
  FDelphiControl.OnFileOpen := FileOpenEvent;
  FDelphiControl.OnResize := ResizeEvent;
  FDelphiControl.OnStyleChange := StyleChangeEvent;
end;

function TPlotX.Get_About: WideString;
begin
  Result := WideString(FDelphiControl.About);
end;

function TPlotX.Get_AxesProperties: WideString;
begin
  Result := WideString(FDelphiControl.AxesProperties);
end;

function TPlotX.Get_BevelInner: TxBevelCut;
begin
  Result := Ord(FDelphiControl.BevelInner);
end;

function TPlotX.Get_BevelOuter: TxBevelCut;
begin
  Result := Ord(FDelphiControl.BevelOuter);
end;

function TPlotX.Get_BorderStyle: TxBorderStyle;
begin
  Result := Ord(FDelphiControl.BorderStyle);
end;

function TPlotX.Get_ClickAndDragDelay: Integer;
begin
  Result := FDelphiControl.ClickAndDragDelay;
end;

function TPlotX.Get_Color: OLE_COLOR;
begin
  Result := OLE_COLOR(FDelphiControl.Color);
end;

function TPlotX.Get_ColumnGap: Smallint;
begin
  Result := Smallint(FDelphiControl.ColumnGap);
end;

function TPlotX.Get_ContourDetail: TxContourDetail;
begin
  Result := Ord(FDelphiControl.ContourDetail);
end;

function TPlotX.Get_CreatedBy: WideString;
begin
  Result := WideString(FDelphiControl.CreatedBy);
end;

function TPlotX.Get_Ctl3D: WordBool;
begin
  Result := FDelphiControl.Ctl3D;
end;

function TPlotX.Get_Cursor: Smallint;
begin
  Result := Smallint(FDelphiControl.Cursor);
end;

function TPlotX.Get_DataProperties: WideString;
begin
  Result := WideString(FDelphiControl.DataProperties);
end;

function TPlotX.Get_DefaultExtension: WideString;
begin
  Result := WideString(FDelphiControl.DefaultExtension);
end;

function TPlotX.Get_Description: WideString;
begin
  Result := WideString(FDelphiControl.Description);
end;

function TPlotX.Get_DisplayHistory: Single;
begin
  Result := FDelphiControl.DisplayHistory;
end;

function TPlotX.Get_DisplayMode: TxDisplayMode;
begin
  Result := Ord(FDelphiControl.DisplayMode);
end;

function TPlotX.Get_DockSite: WordBool;
begin
  Result := FDelphiControl.DockSite;
end;

function TPlotX.Get_DoubleBuffered: WordBool;
begin
  Result := FDelphiControl.DoubleBuffered;
end;

function TPlotX.Get_DragCursor: Smallint;
begin
  Result := Smallint(FDelphiControl.DragCursor);
end;

function TPlotX.Get_DragMode: TxDragMode;
begin
  Result := Ord(FDelphiControl.DragMode);
end;

function TPlotX.Get_Editable: WordBool;
begin
  Result := FDelphiControl.Editable;
end;

function TPlotX.Get_Enabled: WordBool;
begin
  Result := FDelphiControl.Enabled;
end;

function TPlotX.Get_FileName: WideString;
begin
  Result := WideString(FDelphiControl.FileName);
end;

function TPlotX.Get_Font: IFontDisp;
begin
  GetOleFont(FDelphiControl.Font, Result);
end;

function TPlotX.Get_FullRepaint: WordBool;
begin
  Result := FDelphiControl.FullRepaint;
end;

function TPlotX.Get_Grid: TxGridType;
begin
  Result := Ord(FDelphiControl.Grid);
end;

function TPlotX.Get_GridStyle: TxPenStyle;
begin
  Result := Ord(FDelphiControl.GridStyle);
end;

function TPlotX.Get_HelpFile: WideString;
begin
  Result := WideString(FDelphiControl.HelpFile);
end;

function TPlotX.Get_HighFont: IFontDisp;
begin
  GetOleFont(FDelphiControl.HighFont, Result);
end;

function TPlotX.Get_Locked: WordBool;
begin
  Result := FDelphiControl.Locked;
end;

function TPlotX.Get_Movable: WordBool;
begin
  Result := FDelphiControl.Movable;
end;

function TPlotX.Get_MultiJoin: WideString;
begin
  Result := WideString(FDelphiControl.MultiJoin);
end;

function TPlotX.Get_Multiplicity: Byte;
begin
  Result := FDelphiControl.Multiplicity;
end;

function TPlotX.Get_NoSeries: Word;
begin
  Result := FDelphiControl.NoSeries;
end;

function TPlotX.Get_NoYAxes: Integer;
begin
  Result := FDelphiControl.NoYAxes;
end;

function TPlotX.Get_OutlineWidth: Integer;
begin
  Result := FDelphiControl.OutlineWidth;
end;

function TPlotX.Get_ParentColor: WordBool;
begin
  Result := FDelphiControl.ParentColor;
end;

function TPlotX.Get_ParentCtl3D: WordBool;
begin
  Result := FDelphiControl.ParentCtl3D;
end;

function TPlotX.Get_PieRowCount: Byte;
begin
  Result := FDelphiControl.PieRowCount;
end;

function TPlotX.Get_PlotType: TxPlotType;
begin
  Result := Ord(FDelphiControl.PlotType);
end;

function TPlotX.Get_PolarRange: Single;
begin
  Result := FDelphiControl.PolarRange;
end;

function TPlotX.Get_PrintOrientation: TxPrinterOrientation;
begin
  Result := Ord(FDelphiControl.PrintOrientation);
end;

function TPlotX.Get_ScreenJob: TxScreenJob;
begin
  Result := Ord(FDelphiControl.ScreenJob);
end;

function TPlotX.Get_SeriesProperties: WideString;
begin
  Result := WideString(FDelphiControl.SeriesProperties);
end;

function TPlotX.Get_UseDockManager: WordBool;
begin
  Result := FDelphiControl.UseDockManager;
end;

function TPlotX.Get_Visible: WordBool;
begin
  Result := FDelphiControl.Visible;
end;

function TPlotX.Get_VisibleDockClientCount: Integer;
begin
  Result := FDelphiControl.VisibleDockClientCount;
end;

function TPlotX.Get_XYFastDrawAt: Integer;
begin
  Result := FDelphiControl.XYFastDrawAt;
end;

function TPlotX.Get_ZAngle: Word;
begin
  Result := FDelphiControl.ZAngle;
end;

function TPlotX.Get_ZLink: WordBool;
begin
  Result := FDelphiControl.ZLink;
end;

procedure TPlotX._Set_Font(const Value: IFontDisp);
begin
  SetOleFont(FDelphiControl.Font, Value);
end;

procedure TPlotX.CanResizeEvent(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
var
  TempNewWidth: Integer;
  TempNewHeight: Integer;
  TempResize: WordBool;
begin
  TempNewWidth := Integer(NewWidth);
  TempNewHeight := Integer(NewHeight);
  TempResize := WordBool(Resize);
  if FEvents <> nil then FEvents.OnCanResize(TempNewWidth, TempNewHeight, TempResize);
  NewWidth := Integer(TempNewWidth);
  NewHeight := Integer(TempNewHeight);
  Resize := Boolean(TempResize);
end;

procedure TPlotX.ClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnClick;
end;

procedure TPlotX.ConstrainedResizeEvent(Sender: TObject; var MinWidth,
  MinHeight, MaxWidth, MaxHeight: Integer);
var
  TempMinWidth: Integer;
  TempMinHeight: Integer;
  TempMaxWidth: Integer;
  TempMaxHeight: Integer;
begin
  TempMinWidth := Integer(MinWidth);
  TempMinHeight := Integer(MinHeight);
  TempMaxWidth := Integer(MaxWidth);
  TempMaxHeight := Integer(MaxHeight);
  if FEvents <> nil then FEvents.OnConstrainedResize(TempMinWidth, TempMinHeight, TempMaxWidth, TempMaxHeight);
  MinWidth := Integer(TempMinWidth);
  MinHeight := Integer(TempMinHeight);
  MaxWidth := Integer(TempMaxWidth);
  MaxHeight := Integer(TempMaxHeight);
end;

procedure TPlotX.DataChangeEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDataChange;
end;

procedure TPlotX.DblClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDblClick;
end;

procedure TPlotX.FileCloseEvent(Sender: TObject; TheFile: String);
begin
  if FEvents <> nil then FEvents.OnFileClose(WideString(TheFile));
end;

procedure TPlotX.FileOpenEvent(Sender: TObject; TheFile: String);
begin
  if FEvents <> nil then FEvents.OnFileOpen(WideString(TheFile));
end;

procedure TPlotX.ResizeEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnResize;
end;

procedure TPlotX.Set_About(const Value: WideString);
begin
  FDelphiControl.About := String(Value);
end;

procedure TPlotX.Set_AxesProperties(const Value: WideString);
begin
  FDelphiControl.AxesProperties := String(Value);
end;

procedure TPlotX.Set_BevelInner(Value: TxBevelCut);
begin
  FDelphiControl.BevelInner := TBevelCut(Value);
end;

procedure TPlotX.Set_BevelOuter(Value: TxBevelCut);
begin
  FDelphiControl.BevelOuter := TBevelCut(Value);
end;

procedure TPlotX.Set_BorderStyle(Value: TxBorderStyle);
begin
  FDelphiControl.BorderStyle := TBorderStyle(Value);
end;

procedure TPlotX.Set_ClickAndDragDelay(Value: Integer);
begin
  FDelphiControl.ClickAndDragDelay := Value;
end;

procedure TPlotX.Set_Color(Value: OLE_COLOR);
begin
  FDelphiControl.Color := TColor(Value);
end;

procedure TPlotX.Set_ColumnGap(Value: Smallint);
begin
  FDelphiControl.ColumnGap := TPercent(Value);
end;

procedure TPlotX.Set_ContourDetail(Value: TxContourDetail);
begin
  FDelphiControl.ContourDetail := TContourDetail(Value);
end;

procedure TPlotX.Set_CreatedBy(const Value: WideString);
begin
  FDelphiControl.CreatedBy := String(Value);
end;

procedure TPlotX.Set_Ctl3D(Value: WordBool);
begin
  FDelphiControl.Ctl3D := Value;
end;

procedure TPlotX.Set_Cursor(Value: Smallint);
begin
  FDelphiControl.Cursor := TCursor(Value);
end;

procedure TPlotX.Set_DataProperties(const Value: WideString);
begin
  FDelphiControl.DataProperties := String(Value);
end;

procedure TPlotX.Set_DefaultExtension(const Value: WideString);
begin
  FDelphiControl.DefaultExtension := String(Value);
end;

procedure TPlotX.Set_Description(const Value: WideString);
begin
  FDelphiControl.Description := String(Value);
end;

procedure TPlotX.Set_DisplayHistory(Value: Single);
begin
  FDelphiControl.DisplayHistory := Value;
end;

procedure TPlotX.Set_DisplayMode(Value: TxDisplayMode);
begin
  FDelphiControl.DisplayMode := TDisplayMode(Value);
end;

procedure TPlotX.Set_DockSite(Value: WordBool);
begin
  FDelphiControl.DockSite := Value;
end;

procedure TPlotX.Set_DoubleBuffered(Value: WordBool);
begin
  FDelphiControl.DoubleBuffered := Value;
end;

procedure TPlotX.Set_DragCursor(Value: Smallint);
begin
  FDelphiControl.DragCursor := TCursor(Value);
end;

procedure TPlotX.Set_DragMode(Value: TxDragMode);
begin
  FDelphiControl.DragMode := TDragMode(Value);
end;

procedure TPlotX.Set_Editable(Value: WordBool);
begin
  FDelphiControl.Editable := Value;
end;

procedure TPlotX.Set_Enabled(Value: WordBool);
begin
  FDelphiControl.Enabled := Value;
end;

procedure TPlotX.Set_FileName(const Value: WideString);
begin
  FDelphiControl.FileName := String(Value);
end;

procedure TPlotX.Set_Font(var Value: IFontDisp);
begin
  SetOleFont(FDelphiControl.Font, Value);
end;

procedure TPlotX.Set_FullRepaint(Value: WordBool);
begin
  FDelphiControl.FullRepaint := Value;
end;

procedure TPlotX.Set_Grid(Value: TxGridType);
begin
  FDelphiControl.Grid := TGridType(Value);
end;

procedure TPlotX.Set_GridStyle(Value: TxPenStyle);
begin
  FDelphiControl.GridStyle := TPenStyle(Value);
end;

procedure TPlotX.Set_HelpFile(const Value: WideString);
begin
  FDelphiControl.HelpFile := String(Value);
end;

procedure TPlotX.Set_HighFont(const Value: IFontDisp);
begin
  SetOleFont(FDelphiControl.HighFont, Value);
end;

procedure TPlotX.Set_Locked(Value: WordBool);
begin
  FDelphiControl.Locked := Value;
end;

procedure TPlotX.Set_Movable(Value: WordBool);
begin
  FDelphiControl.Movable := Value;
end;

procedure TPlotX.Set_MultiJoin(const Value: WideString);
begin
  FDelphiControl.MultiJoin := String(Value);
end;

procedure TPlotX.Set_Multiplicity(Value: Byte);
begin
  FDelphiControl.Multiplicity := Value;
end;

procedure TPlotX.Set_NoSeries(Value: Word);
begin
  FDelphiControl.NoSeries := Value;
end;

procedure TPlotX.Set_NoYAxes(Value: Integer);
begin
  FDelphiControl.NoYAxes := Value;
end;

procedure TPlotX.Set_OutlineWidth(Value: Integer);
begin
  FDelphiControl.OutlineWidth := Value;
end;

procedure TPlotX.Set_ParentColor(Value: WordBool);
begin
  FDelphiControl.ParentColor := Value;
end;

procedure TPlotX.Set_ParentCtl3D(Value: WordBool);
begin
  FDelphiControl.ParentCtl3D := Value;
end;

procedure TPlotX.Set_PieRowCount(Value: Byte);
begin
  FDelphiControl.PieRowCount := Value;
end;

procedure TPlotX.Set_PlotType(Value: TxPlotType);
begin
  FDelphiControl.PlotType := TPlotType(Value);
end;

procedure TPlotX.Set_PolarRange(Value: Single);
begin
  FDelphiControl.PolarRange := Value;
end;

procedure TPlotX.Set_PrintOrientation(Value: TxPrinterOrientation);
begin
  FDelphiControl.PrintOrientation := TPrinterOrientation(Value);
end;

procedure TPlotX.Set_ScreenJob(Value: TxScreenJob);
begin
  FDelphiControl.ScreenJob := TScreenJob(Value);
end;

procedure TPlotX.Set_SeriesProperties(const Value: WideString);
begin
  FDelphiControl.SeriesProperties := String(Value);
end;

procedure TPlotX.Set_UseDockManager(Value: WordBool);
begin
  FDelphiControl.UseDockManager := Value;
end;

procedure TPlotX.Set_Visible(Value: WordBool);
begin
  FDelphiControl.Visible := Value;
end;

procedure TPlotX.Set_XYFastDrawAt(Value: Integer);
begin
  FDelphiControl.XYFastDrawAt := Value;
end;

procedure TPlotX.Set_ZAngle(Value: Word);
begin
  FDelphiControl.ZAngle := Value;
end;

procedure TPlotX.Set_ZLink(Value: WordBool);
begin
  FDelphiControl.ZLink := Value;
end;

procedure TPlotX.StyleChangeEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnStyleChange;
end;

initialization
  TActiveXControlFactory.Create(
    ComServer,
    TPlotX,
    TPlot,
    Class_PlotX,
    1,
    '{618FBFA4-4B23-11D5-AC76-006008F62500}',
    OLEMISC_SIMPLEFRAME or OLEMISC_ACTSLIKELABEL,
    tmSingle);
end.
