// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Plotdefs.pas' rev: 3.00

#ifndef PlotdefsHPP
#define PlotdefsHPP
#include <Windows.hpp>
#include <Menus.hpp>
#include <Classes.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Plotdefs
{
//-- type declarations -------------------------------------------------------
typedef Menus::TMenuItem* TMenuArray[128];

typedef TMenuArray *pMenuArray;

enum TPlotType { ptXY, ptError, ptMultiple, ptBubble, ptColumn, ptStack, ptNormStack, ptPie, ptPolar, 
	ptContour, pt3DContour, pt3DWire };

enum TScreenJob { sjNone, sjDrag, sjRightDrag, sjHide, sjZoomIn, sjEditAxis, sjTouchNotePointer, sjMoveNotePointer, 
	sjEditFont, sjEditPoint, sjEditSeries, sjFlashEdit, sjCopySeries, sjDisplace, sjCloneSeries, sjDeleteSeries, 
	sjLinearize, sjZero, sjPosition, sjNearestPoint, sjAverage, sjContractSeries, sjContractAllSeries, 
	sjSplineSeries, sjHighs, sjLows, sjMovingAverage, sjSmoothSeries, sjSortSeries, sjDifferentiate, sjIntegrate, 
	sjIntegral, sjLineOfBestFit, sjDualLineBestFit1, sjDualLineBestFit2, sjSelection, sjDualSelection1, 
	sjDualSelection2 };

enum TObjectType { soNone, soTitle, soLegend, soResult, soNote, soXAxis, soXAxisTitle, soXAxisLabel, 
	soYAxis, soYAxisTitle, soYAxisLabel, soLeftBorder, soTopBorder, soRightBorder, soBottomBorder, soSeries 
	};

enum TDisplayMode { dmNormal, dmNone, dmRun, dmHistory };

enum TContourDetail { cdLow, cdMedium, cdHigh, cdVHigh };

enum TGridType { gtNone, gtHorizontal, gtVertical, gtBoth };

enum TSymbol { syNone, syCircle, sySquare, syUpTriangle, syDownTriangle, syPlus, syCross, syStar, syDash, 
	syVertDash, syLeftDash, syRightDash };

enum TMainMenus { mnuFile, mnuEdit, mnuView, mnuCalc };

typedef Set<TMainMenus, mnuFile, mnuCalc>  TMainOptions;

enum TFileMenus { mnuNew, mnuOpen, mnuOverlayDiv, mnuOverlay, mnuClearOverlays, mnuSaveDiv, mnuSave, 
	mnuSaveAs, mnuSaveImage, mnuPrintDiv, mnuPrint };

typedef Set<TFileMenus, mnuNew, mnuPrint>  TFileOptions;

enum TEditMenus { mnuCopy, mnuCopyHTML, mnuCopySeries, mnuPaste, mnuDisplaceDiv, mnuDisplace, mnuResetDisplacement, 
	mnuEditSeriesDiv, mnuNewSeries, mnuCloneSeries, mnuEditPoint, mnuEditData, mnuEditSeries, mnuDeleteSeries, 
	mnuLinearize, mnuZero, mnuAxisDiv, mnuNewY2Axis, mnuEditAxis, mnuDeleteY2Axis, mnuEditFontDiv, mnuNewNote, 
	mnuMoveNotePointer, mnuDeleteNote, mnuEditFont, mnuEditPropertiesDiv, mnuEditProperties };

typedef Set<TEditMenus, mnuCopy, mnuEditProperties>  TEditOptions;

enum TViewMenus { mnuHide, mnuShowAll, mnuDisplayModeDiv, mnuDisplayMode, mnuLegend, mnuZoomDiv, mnuSetAsNormal, 
	mnuNormalView, mnuManualZoom, mnuZoomIn, mnuZoomOut };

typedef Set<TViewMenus, mnuHide, mnuZoomOut>  TViewOptions;

enum TCalcMenus { mnuPosition, mnuNearestPoint, mnuCalcAverageDiv, mnuCalcAverage, mnuCompressSeries, 
	mnuCompressAllSeries, mnuContractSeries, mnuContractAllSeries, mnuCubicSplineSeries, mnuHighs, mnuMovingAverage, 
	mnuSmoothSeries, mnuSortSeries, mnuCalculusDiv, mnuDifferentiate, mnuIntegrate, mnuIntegral, mnuLineOfBestFitDiv, 
	mnuLineOfBestFit, mnuTwoRegionLineOfBestFit };

typedef Set<TCalcMenus, mnuPosition, mnuTwoRegionLineOfBestFit>  TCalcOptions;

enum TModeMenus { mnuNormal, mnuNone, mnuRun, mnuHistory };

enum TSaveOption { soAsText, soProperties };

typedef Set<TSaveOption, soAsText, soProperties>  TSaveOptions;

struct T3DPoint
{
	int x;
	int y;
	float Z;
	tagPOINT ZShift;
} ;

typedef tagPOINT TPoints[601];

typedef TPoints *pTPoints;

class DELPHICLASS TPopupOptions;
class PASCALIMPLEMENTATION TPopupOptions : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TMainOptions FMenu;
	TFileOptions FFile;
	TEditOptions FEdit;
	TViewOptions FView;
	TCalcOptions FCalc;
	
protected:
	virtual void __fastcall AssignTo(Classes::TPersistent* Dest);
	
public:
	__fastcall TPopupOptions(void);
	
__published:
	__property TMainOptions Menu = {read=FMenu, write=FMenu, nodefault};
	__property TFileOptions File_ = {read=FFile, write=FFile, nodefault};
	__property TEditOptions Edit = {read=FEdit, write=FEdit, nodefault};
	__property TViewOptions View = {read=FView, write=FView, nodefault};
	__property TCalcOptions Calc = {read=FCalc, write=FCalc, nodefault};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TPopupOptions(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define TPLOT_VERSION (Byte)(200)
#define FILE_FORMAT_VERSION (Byte)(200)
#define MAX_FILE_VERSION (Byte)(200)
#define TAG_BASE (Word)(1000)
#define CAPTION_BASE (Word)(3000)
#define HINT_BASE (Word)(4000)
#define TWO_PI  (6.283185E+00)
#define PI_ON_TWO  (1.570796E+00)
#define THREE_PI_ON_TWO  (4.712389E+00)
#define SMALL_FONT_SIZE (Byte)(8)
#define MEDIUM_FONT_SIZE (Byte)(9)
#define LARGE_FONT_SIZE (Byte)(14)
extern PACKAGE System::ResourceString _sArial;
#define Plotdefs_sArial System::LoadResourceString(&Plotdefs::_sArial)

}	/* namespace Plotdefs */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Plotdefs;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Plotdefs
