{ ****************************************************************** }
{                                                                    }
{   VCL component TAtdbedit                                          }
{                                                                    }
{   Generated on 25 May 2001 at 15:18                                }
{                                                                    }
{   Copyright  2001 by ATSoftware                                   }
{                                                                    }
{ ****************************************************************** }

unit Atdbedit;

interface

uses WinTypes, WinProcs, Messages, SysUtils, Classes, Controls,
     Forms, Graphics, Dbctrls;

type
  TAtdbedit = class(TDbEdit)
    private
        FInColor : TColor;
        FOutColor : TColor;

      { Private methods of TAtdbedit }
        procedure AutoInitialize;
        function GetInColor : TColor;
        procedure SetInColor(Value : TColor);
        function GetOutColor : TColor;
        procedure SetOutColor(Value : TColor);

    protected
      { Protected fields of TAtdbedit }
        procedure Change; override;
        procedure Click; override;
        procedure DoEnter; override;
        procedure KeyPress(var Key : Char); override;
        procedure Loaded; override;
        procedure MouseEnter (var Msg: TMessage);
                  message cm_MouseEnter;
        procedure MouseLeave  (var Msg: TMessage);
                  message cm_MouseLeave;

    public
      { Public methods of TAtdbedit }
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;

    published
      { Published properties of TAtdbedit }
        property OnChange;
        property OnClick;
        property OnDblClick;
        property OnDragDrop;
        property OnExit;
        property OnKeyDown;
        property OnKeyPress;
        property OnKeyUp;
        property OnMouseDown;
        property OnMouseMove;
        property OnMouseUp;
        property InColor : TColor
             read GetInColor write SetInColor
             default clAqua;
        property OutColor : TColor
             read GetOutColor write SetOutColor
             default clWhite;

  end;

procedure Register;

implementation

procedure Register;
begin
     RegisterComponents('Data Controls', [TAtdbedit]);
end;

{ Method to set variable and property values and create objects }
procedure TAtdbedit.AutoInitialize;
begin
     FInColor := clAqua;
     FOutColor := clWhite;
end;


{ Read method for property InColor }
function TAtdbedit.GetInColor : TColor;
begin
     Result := FInColor;
end;

{ Write method for property InColor }
procedure TAtdbedit.SetInColor(Value : TColor);
begin
     FInColor := Value;
end;

{ Read method for property OutColor }
function TAtdbedit.GetOutColor : TColor;
begin
     Result := FOutColor;
end;

{ Write method for property OutColor }
procedure TAtdbedit.SetOutColor(Value : TColor);
begin
     FOutColor := Value;
end;

{ Override OnChange handler from TDbEdit }
procedure TAtdbedit.Change;
begin
     inherited Change;
end;

{ Override OnClick handler from TDbEdit }
procedure TAtdbedit.Click;
begin
     inherited Click;
end;

{ Override OnEnter handler from TDbEdit }
procedure TAtdbedit.DoEnter;
begin
     inherited DoEnter;
end;

{ Override OnKeyPress handler from TDbEdit }
procedure TAtdbedit.KeyPress(var Key : Char);
const
     TabKey = Char(VK_TAB);
     EnterKey = Char(VK_RETURN);
begin
     inherited KeyPress(Key);
end;

constructor TAtdbedit.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     AutoInitialize;
end;

destructor TAtdbedit.Destroy;
begin
     inherited Destroy;
end;

procedure TAtdbedit.Loaded;
begin
     inherited Loaded;
end;

procedure TAtdbedit.MouseEnter;
begin
 color := FInColor;
 font.Style := font.style + [fsBold];
 cursor := crUpArrow;
 showHint:=true;
 hint := DataField;
end;



procedure TAtdbedit.MouseLeave;
begin
 color := FOutColor;
 font.Style := font.style - [fsBold];
 cursor := crDefault;
 showHint:=false;
end;


end.
