unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FtpSearch, ComCtrls, ExtCtrls, ImgList, Menus;

type
  TfrmMain = class(TForm)
    MFtpSearch1: TMFtpSearch;
    Button1: TButton;
    Button2: TButton;
    ListView1: TListView;
    StatusBar1: TStatusBar;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    ComboBox1: TComboBox;
    Bevel1: TBevel;
    ImageList1: TImageList;
    PopupMenu1: TPopupMenu;
    ftpsearchlycoscom801: TMenuItem;
    ftpsunetse80001: TMenuItem;
    archieiscoza801: TMenuItem;
    ftpsearchcityru801: TMenuItem;
    wolandaftinsuru80001: TMenuItem;
    unicornnetlabistsukubaacjp801: TMenuItem;
    ftprikengojp80001: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MFtpSearch1SearchInfo(Sender: TObject; info: TMFtpSearchInfo;
      addinfo: String);
    procedure ListView1InfoTip(Sender: TObject; Item: TListItem;
      var InfoTip: String);
    procedure menuClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.Button1Click(Sender: TObject);
var i: Integer;
begin
   Edit1.Enabled := False;
   Button1.Enabled := False;
   ComboBox1.Enabled := False;

   with MFtpSearch1 do
   begin
      Filename := Edit1.Text;
      SearchType := TMFtpSearchType(ComboBox1.ItemIndex);

      Server.Clear;
      for i := 0 to PopupMenu1.Items.Count - 1 do
         if PopupMenu1.Items[i].Checked then
            Server.Add(PopupMenu1.Items[i].Caption);

      Search;
   end;

   Edit1.Enabled := True;
   Button1.Enabled := True;
   ComboBox1.Enabled := True;
end;

procedure TfrmMain.Button2Click(Sender: TObject);
begin
   Application.Terminate;
end;

procedure TfrmMain.Edit1Change(Sender: TObject);
begin
   Button1.Enabled := (Trim(Edit1.Text) <> '');
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
   ComboBox1.ItemIndex := 0;
end;

procedure TfrmMain.MFtpSearch1SearchInfo(Sender: TObject;
  info: TMFtpSearchInfo; addinfo: String);
var LI: TListItem;
    i: Integer;
begin
   case info of
      searchFileFound:
      begin
         LI := ListView1.Items.Add;

         with LI, MFtpSearch1.Files[MFtpSearch1.Files.Count - 1] do
         begin
            for i := Length(addinfo) downto 1 do
               if addinfo[i] = '/' then Break;
            Caption := Copy(addinfo, i + 1, 999);

            case Attrib[1] of
               'd': ImageIndex := 0;
               'l': ImageIndex := 2;
               else ImageIndex := 1;
            end;

            SubItems.Add(Size);
            SubItems.Add(DateTime);
            SubItems.Add(Attrib);
            SubItems.Add(addinfo);
         end;
      end;
      searchStart: StatusBar1.SimpleText := 'Searching specified file in ' + addinfo;
      searchDone: StatusBar1.SimpleText := 'Ready';
   end;
end;

procedure TfrmMain.ListView1InfoTip(Sender: TObject; Item: TListItem;
  var InfoTip: String);
begin
   if Assigned(Item) then
      InfoTip := Item.SubItems[3]
end;

procedure TfrmMain.menuClick(Sender: TObject);
begin
   (Sender as TMenuItem).Checked := not (Sender as TMenuItem).Checked;
end;

end.
