unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ImgList, Menus, FormEx;

type
  TfrmMain = class(TForm)
    Pager: TPageControl;
    GeneralSheet: TTabSheet;
    lMovementStyle: TLabel;
    cbMovementStyle: TComboBox;
    lAcceptFiles: TLabel;
    cbAcceptFiles: TComboBox;
    lTopMostStyle: TLabel;
    cbTopMostStyle: TComboBox;
    lTaskVisible: TLabel;
    cbTaskVisible: TComboBox;
    Label1: TLabel;
    eResizeBorder: TEdit;
    cbAlwaysOnScreen: TCheckBox;
    bFullScreen: TButton;
    bSendKeys: TButton;
    bFlash: TButton;
    ImageList1: TImageList;
    cbScrollingCaption: TCheckBox;
    cbAnimatedIcon: TCheckBox;
    TrayPopUp: TPopupMenu;
    Close1: TMenuItem;
    cbAnimatedTrayIcon: TCheckBox;
    cbSysMenuEx: TCheckBox;
    SysExPopUp: TPopupMenu;
    N1: TMenuItem;
    FlashWindow1: TMenuItem;
    bCaptureWindow: TButton;
    SaveDialog: TSaveDialog;
    FormEx: TFormEx;
    procedure FormCreate(Sender: TObject);
    procedure cbMovementStyleChange(Sender: TObject);
    procedure cbAcceptFilesChange(Sender: TObject);
    procedure FormExDropFiles(Sender: TObject; var Files: TStrings;
      var Position: TPoint);
    procedure cbTopMostStyleChange(Sender: TObject);
    procedure cbTaskVisibleChange(Sender: TObject);
    procedure FormExMaximize(Sender: TObject);
    procedure FormExMinimize(Sender: TObject);
    procedure eResizeBorderChange(Sender: TObject);
    procedure cbAlwaysOnScreenClick(Sender: TObject);
    procedure FormExRestore(Sender: TObject);
    procedure bFullScreenClick(Sender: TObject);
    procedure bSendKeysClick(Sender: TObject);
    procedure bFlashClick(Sender: TObject);
    procedure cbScrollingCaptionClick(Sender: TObject);
    procedure cbAnimatedIconClick(Sender: TObject);
    procedure FormExTrayIconDblClick(Sender: TObject);
    procedure FormExTrayIconClick(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure cbAnimatedTrayIconClick(Sender: TObject);
    procedure cbSysMenuExClick(Sender: TObject);
    procedure bCaptureWindowClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
 cbMovementStyle.ItemIndex:=0;
 cbTopMostStyle.ItemIndex:=0;
 cbAcceptFiles.ItemIndex:=1;
 cbTaskVisible.ItemIndex:=0;
end;

procedure TfrmMain.cbMovementStyleChange(Sender: TObject);
begin
 Case (Sender as tComboBox).ItemIndex of
 0 : FormEx.Placement.Moveable:=fmsDefault;
 1 : FormEx.Placement.Moveable:=fmsAlways;
 2 : FormEx.Placement.Moveable:=fmsNever;
 End;
end;

procedure TfrmMain.cbAcceptFilesChange(Sender: TObject);
begin
 Case (Sender as tComboBox).ItemIndex of
 0 : FormEx.Appearance.AcceptFiles:=True;
 1 : FormEx.Appearance.AcceptFiles:=False;
 End;
end;

procedure TfrmMain.FormExDropFiles(Sender: TObject; var Files: TStrings;
  var Position: TPoint);
begin
 ShowMessage(Files.Text);
end;

procedure TfrmMain.cbTopMostStyleChange(Sender: TObject);
begin
 Case (Sender as tComboBox).ItemIndex of
 0 : FormEx.Placement.TopMost:=ftmsDefault;
 1 : FormEx.Placement.TopMost:=ftmsAlways;
 2 : FormEx.Placement.TopMost:=ftmsWhenAcceptFiles;
 End;
end;

procedure TfrmMain.cbTaskVisibleChange(Sender: TObject);
begin
 Case (Sender as tComboBox).ItemIndex of
 0 : FormEx.Appearance.ShowOnTaskBar:=ftsDefault;
 1 : FormEx.Appearance.ShowOnTaskBar:=ftsAlways;
 2 : FormEx.Appearance.ShowOnTaskBar:=ftsWhenVisible;
 End;
end;

procedure TfrmMain.FormExMaximize(Sender: TObject);
begin
 ShowMessage('Maximize');
end;

procedure TfrmMain.FormExMinimize(Sender: TObject);
begin
 ShowMessage('Minimize');
end;

procedure TfrmMain.eResizeBorderChange(Sender: TObject);
begin
 FormEx.Resize.BorderWidth:=StrToInt(eResizeBorder.Text);
end;

procedure TfrmMain.cbAlwaysOnScreenClick(Sender: TObject);
begin
 FormEx.Placement.AlwaysOnScreen:=(sender as TCheckBox).Checked;
end;

procedure TfrmMain.FormExRestore(Sender: TObject);
begin
 ShowMessage('Restore');
end;

procedure TfrmMain.bFullScreenClick(Sender: TObject);
begin
 If FormEx.Appearance.FullScreen then
  FormEx.Appearance.FullScreen:=False else
  FormEx.Appearance.FullScreen:=True;
end;

procedure TfrmMain.bSendKeysClick(Sender: TObject);
begin
 WinExec('notepad.exe',SW_NORMAL);
 FormEx.SendKeys(FindWindowEx(FindWindow('Notepad','Untitled - Notepad'),0,'Edit',''),'FormEx -> Notepad SendKeys Demo');
end;

procedure TfrmMain.bFlashClick(Sender: TObject);
begin
 FormEx.Flash(2,100);
end;

procedure TfrmMain.cbScrollingCaptionClick(Sender: TObject);
begin
 FormEx.Appearance.CaptionScroll.Enabled:=(Sender as tCheckBox).Checked;
end;

procedure TfrmMain.cbAnimatedIconClick(Sender: TObject);
begin
 FormEx.Appearance.AnimatedIcon.Enabled:=(Sender as tCheckBox).Checked;
end;

procedure TfrmMain.FormExTrayIconDblClick(Sender: TObject);
begin
 ShowMessage('TrayIcon Double Click');
end;

procedure TfrmMain.FormExTrayIconClick(Sender: TObject);
begin
 ShowMessage('TrayIcon Click');
end;

procedure TfrmMain.Close1Click(Sender: TObject);
begin
 Close;
end;

procedure TfrmMain.cbAnimatedTrayIconClick(Sender: TObject);
begin
 FormEx.TrayIcon.CycleIcons:=(Sender as tCheckBox).Checked;
end;

procedure TfrmMain.cbSysMenuExClick(Sender: TObject);
begin
 If cbSysMenuEx.Checked then
  FormEx.SysMenuEx:=SysExPopUp else
  FormEx.SysMenuEx:=nil;
end;

procedure TfrmMain.bCaptureWindowClick(Sender: TObject);
begin
 If SaveDialog.Execute then
 Begin
  ShowMessage('This program will execute Notepad and capture its window');
  WinExec('notepad.exe',SW_NORMAL);
  FormEx.CaptureWindow(FindWindow('Notepad','Untitled - Notepad'),SaveDialog.Filename);
 End;
end;

end.
