{*******************************************************************************

TDCImageInfo Test Program

 2001 David Crowell

www.davidcrowell.com

Description:
TDCImageInfo returns image type, dimensions, and color depth from GIF, JPEG, PNG,
BMP, PCX, and TIFF files.

This is a port of my CImageInfo class which was created with Visual Basic.

Usage:
var
  ImageInfo: TDCImageInfo;

Begin
  ImageInfo := TDCImageInfo.Create;
  ImageInfo.ReadFile('test.jpg');
  Writeln(ImageInfo.Width);  // etc...
  ImageInfo.Free;

*******************************************************************************}
program IITest;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Classes,
  DCImageInfo in 'DCImageInfo.pas';

var
  ImageInfo: TDCImageInfo;

begin

  Writeln('---------------------------');
  Writeln('TDCImageInfo Test Program');
  Writeln('---------------------------');

  ImageInfo := TDCImageInfo.Create;
  ImageInfo.ReadFile(ParamStr(1));

  Case ImageInfo.ImageType Of
    itUnknown: Writeln('Unknown');
    itPNG: Writeln('PNG');
    itGIF: Writeln('GIF');
    itBMP: Writeln('BMP');
    itPCX: Writeln('PCX');
    itJPEG: Writeln('JPEG');
    itTIFF: Writeln('TIFF');
  Else
    Writeln('Unrecognized file type');
  End;

  Writeln('Width: ' + IntToStr(ImageInfo.Width));
  Writeln('Height: ' + IntToStr(ImageInfo.Height));
  Writeln('Depth: ' + IntToStr(ImageInfo.Depth));

  ImageInfo.Free;

end.
